#include <stdio.h>
#include <conio.h>
#include <graphics.h>
#include <dos.h>
#define ESC 0x1b
void sound(unsigned frequnecy);
void delay(unsigned milliseconds);
void nosound(void);


pause()      /* to get the user response */
{
int c=0;

while(c!=ESC)
{
   c = getch();
   switch (c) {
	  case 't':
	  case 'T':   return;
	  case 'm':
	  case 'M':   cleardevice();
		      menu();
		      break;
	  default:    sound(500);
		      delay(100);
		      nosound();
		      break;
	       }
}
closegraph();
exit(1);
}


int gprintf( int *xloc, int *yloc, char *fmt, ...)   /*print program on */
{                                                  /*the right hand corner*/
  va_list argptr;
  char str[140];
  int cnt;

  va_start(argptr,format);

  cnt = vsprintf( str, fmt,argptr);
  outtextxy( *xloc, *yloc, str );
  *yloc += textheight("H") + 4;

  va_end( argptr);

  return(cnt);

}


int rprintf(int xloc, int yloc, char *fmt,int color, ... ) /*print byte size*/
								/*content*/
{                                                          /*on given loca*/
va_list argptr;
char str[140];
int cnt,xxloc,yyloc;

xxloc = xloc + 16 ;
yyloc = yloc + 8 ;
setviewport(xloc,yloc,xxloc,yyloc,1);
clearviewport();
setviewport(0,0,639,349,1);
va_start( argptr, format );
setcolor(color);
cnt = vsprintf( str, fmt, argptr );
outtextxy( xloc, yloc, str );

va_end( argptr );

return( cnt );

}

int flagprin(int xloc, int yloc, char *fmt,int color, ... ) /*print byte size*/
								/*content*/
{                                                          /*on given loca*/
va_list argptr;
char str[140];
int cnt,xxloc,yyloc;

xxloc = xloc + 8 ;
yyloc = yloc + 8 ;
setviewport(xloc,yloc,xxloc,yyloc,1);
clearviewport();
setviewport(0,0,639,349,1);
va_start( argptr, format );
setcolor(color);
cnt = vsprintf( str, fmt, argptr );
outtextxy( xloc, yloc, str );

va_end( argptr );

return( cnt );

}

int Iarrow(int xloc,int yloc,char *fmt, ...)  /* station '>' */
{
va_list argptr;
char str[140];
int cnt,xxloc,yyloc,yyyloc;

xxloc = xloc +  8;
yyloc = yloc ;
yyyloc = yloc ;
setviewport(xloc,yyloc,xxloc,yyyloc,1);
clearviewport();
setviewport(0,0,639,349,1);
va_start( argptr, format );
cnt = vsprintf( str, fmt, argptr );
setcolor(14);
outtextxy(xloc,yloc,str);
setcolor(WHITE);
va_end( argptr );
return(cnt);
}


csarrow( int xloc, int yloc  )	/* give blinking arrow on CS */
{
 setcolor(14);
 outtextxy( xloc, yloc, ">" );
 setcolor(0);
 delay(50);
 outtextxy( xloc, yloc, ">" );
}



int ipprintf( int xloc, int yloc, char *fmt, ... ) /* give blink effect*/
{                                                  /*for 'IP'*/
va_list argptr;
char str[140];
int cnt;

va_start( argptr, format );

cnt = vsprintf(str, fmt, argptr );
setcolor(14);
outtextxy( xloc, yloc, str );
setcolor(BLACK);
delay(50);
outtextxy( xloc, yloc, str );
setcolor(WHITE);

va_end( argptr );

return( cnt );
}



int ptprintf(int xloc, int yloc, char *fmt,int color, ... ) /*display on ptr*/
{                                                          /* and idx */
va_list argptr;
char str[140];
int cnt,xxloc,yyloc;

xxloc = xloc + 32 ;
yyloc = yloc + 8 ;
setviewport(xloc,yloc,xxloc,yyloc,1);
clearviewport();
setviewport(0,0,639,349,1);
va_start( argptr, format );
setcolor(color);
cnt = vsprintf( str, fmt, argptr );
outtextxy( xloc, yloc, str );

va_end( argptr );

return( cnt );

}

flag0(int xloc, int yloc )
{
  setcolor(0);
  outtextxy(xloc, yloc, "1");
  setcolor(13);
  outtextxy(xloc, yloc, "0");
  }

pflag0(int xloc, int yloc )
{
  setcolor(0);
  outtextxy(xloc, yloc, "1");
  setcolor(15);
  outtextxy(xloc, yloc, "0");
  }

flag1(int xloc, int yloc )
{
  setcolor(0);
  outtextxy(xloc, yloc, "0");
  setcolor(13);
  outtextxy(xloc, yloc, "1");
  }

pflag1(int xloc, int yloc )
{
  setcolor(0);
  outtextxy(xloc, yloc, "0");
  setcolor(15);
  outtextxy(xloc, yloc, "1");
  }