/* THIS FUNCTIONS SERVES TO DISPLAY THE EFFECTS ON THE VARIOUS */
/* SEGMENT CONTENTS AND INTERNAL REGISTERS AS THE INSTRUCTIONS */
/* IN LOGICAL EXAMPLE PROGRAM ARE TRACED THROUGH */

#include <stdio.h>
#include <graphics.h>
#include <conio.h>
#include <dos.h>
#define ESC 0x1b

logical_eg()
{
  int x=470,y=206,c=0;
  Model();
  location();
  setviewport(0,0,635,349,1);
  setcolor(14);
  gprintf(&x,&y,"AND CL,36H");
  setcolor(15);
  gprintf(&x,&y,"OR DX,8081H");
  gprintf(&x,&y,"XOR AX,AX");
  gprintf(&x,&y,"NOT CH");
  gprintf(&x,&y,"TEST BH,BL");

  rprintf(517,42,"31",15);	    /* registers initialised */
  rprintf(517,56,"9A",15);
  rprintf(517,70,"07",15);
  rprintf(517,84,"1E",15);
  rprintf(600,42,"09",15);
  rprintf(600,56,"F0",15);
  rprintf(600,70,"85",15);
  rprintf(600,84,"3D",15);

  ptprintf(419,98,"0000",14);

  rprintf(477,152,"80",14);          /* queue */
  rprintf(503,152,"E1",14);
  rprintf(530,152,"36",14);
  rprintf(558,152,"81",15);
  rprintf(585,152,"C0",15);
  rprintf(612,152,"80",15);
				/* flags */
  outtextxy(409,132,"-");       /* OF */
  outtextxy(432,132,"-");       /* DF */
  outtextxy(456,132,"-");       /* IF */
  outtextxy(480,132,"-");       /* TF */
  outtextxy(503,132,"-");       /* SF */
  outtextxy(527,132,"-");       /* ZF */
  outtextxy(551,132,"-");       /* AF */
  outtextxy(575,132,"-");       /* PF */
  outtextxy(598,132,"-");       /* CF */

  rprintf(236,73,"80",15);        /* machine code */
  rprintf(328,73,"E1",15);
  rprintf(236,88,"36",15);
  rprintf(328,88,"81",15);
  rprintf(236,103,"CA",15);
  rprintf(328,103,"80",15);
  rprintf(236,118,"81",15);
  rprintf(328,118,"33",15);
  rprintf(236,133,"C0",15);
  rprintf(328,133,"F6",15);
  rprintf(236,148,"D5",15);
  rprintf(328,148,"84",15);
  rprintf(236,163,"FB",15);

  Iarrow(193,73,">");

  setviewport(0,0,639,349,1);


  lpause();
  lchange1();
  lpause();
  lchange2();
  lpause();
  lchange3();
  lpause();
  lchange4();
  lpause();
  lchange5();
  lpause();
  while(c!=ESC)
  {
    c=getch();
    switch(c) {
	   case ESC : break;
	   case 'q' :
	   case 'Q' : closegraph();
		      exit(1);
	   case 'r' :
	   case 'R' : cleardevice();
		      logical_eg();
		      break;
	   default  : sound(500);
		      delay(100);
		      nosound();
		      break;
		}
  }
  cleardevice();
  log_menu();
  }

  lpause()                           /* puase function */
  {
  int c=0;

  while(c!=ESC)
  {
    c=getch();
    switch(c) {
	   case ESC : break;
	   case 'q' :
	   case 'Q' : closegraph();
		      exit(1);
	   case 'r' :
	   case 'R' : cleardevice();
		      logical_eg();
		      break;
	   case 't' :
	   case 'T' : return;
	   default  : sound(500);
		      delay(100);
		      nosound();
		      break;
		}
  }

  cleardevice();
  log_menu();
  }

  lchange1()
  {
    flagprin(409,132,"0",15);       /* OF */
    flagprin(432,132,"1",15);       /* DF */
    flagprin(456,132,"1",15);       /* IF */
    flagprin(480,132,"1",15);       /* TF */
    flagprin(503,132,"0",15);       /* SF */
    flagprin(527,132,"0",15);       /* ZF */
    flagprin(551,132,"0",15);       /* AF */
    flagprin(575,132,"0",15);       /* PF */
    flagprin(598,132,"0",15);       /* CF */

    setcolor(13);
    outtextxy(470,206,"AND CL,36H");
    setcolor(14);
    outtextxy(470,218,"OR DX,8081H");

    rprintf(477,152,"81",14);          /* queue */
    rprintf(503,152,"CA",14);
    rprintf(530,152,"80",14);
    rprintf(558,152,"81",14);
    rprintf(585,152,"33",15);
    rprintf(612,152,"C0",15);



    csarrow(193,73);                    /* ptr. change */
    ipprintf(419,98,"0001");
    csarrow(285,73);
    ipprintf(419,98,"0002");
    csarrow(193,88);
    ptprintf(419,98,"0003",14);
    Iarrow(285,88,">");

    rprintf(600,70,"04",13);
    }

  lchange2()
  {
    setcolor(15);
    outtextxy(470,206,"AND CL,36H");
    setcolor(13);
    outtextxy(470,218,"OR DX,8081H");
    rprintf(600,70,"04",15);

    rprintf(477,152,"33",14);              /* queue */
    rprintf(503,152,"C0",14);
    rprintf(530,152,"F6",15);
    rprintf(558,152,"D5",15);
    rprintf(585,152,"84",15);
    rprintf(612,152,"FB",15);

    csarrow(285,88);                      /* ptr. change */
    ipprintf(419,98,"0004");
    csarrow(193,103);
    ipprintf(419,98,"0005");
    csarrow(285,103);
    ipprintf(419,98,"0006");
    csarrow(193,118);
    ptprintf(419,98,"0007",14);
    Iarrow(285,118,">");

    setcolor(14);
    outtextxy(470,230,"XOR AX,AX");
    flag1(575,132);
    flag1(503,132);
    rprintf(517,84,"9E",13);
    rprintf(600,84,"BD",13);

    }

  lchange3()
  {
    setcolor(15);
    outtextxy(470,218,"OR DX,8081H");
    setcolor(13);
    outtextxy(470,230,"XOR AX,AX");
    rprintf(517,84,"9E",15);
    rprintf(600,84,"BD",15);

    rprintf(477,152,"F6",14);              /* queue */
    rprintf(503,152,"D5",14);
    rprintf(530,152,"84",15);
    rprintf(558,152,"FB",15);
    rprintf(585,152,"--",15);
    rprintf(612,152,"--",15);

    csarrow(285,118);                      /* ptr. change */
    ipprintf(419,98,"0008");
    csarrow(193,133);
    ptprintf(419,98,"0009",14);
    Iarrow(285,133,">");

    setcolor(14);
    outtextxy(470,242,"NOT CH");
    pflag1(575,132);
    flag0(503,132);
    flag1(527,132);
    rprintf(517,42,"00",13);
    rprintf(600,42,"00",13);
    }

  lchange4()
  {
    setcolor(15);
    outtextxy(470,230,"XOR AX,AX");
    setcolor(13);
    outtextxy(470,242,"NOT CH");
    rprintf(517,42,"00",15);
    rprintf(600,42,"00",15);

    rprintf(477,152,"84",14);              /* queue */
    rprintf(503,152,"FB",14);
    rprintf(530,152,"--",15);
    rprintf(558,152,"--",15);
    rprintf(585,152,"--",15);
    rprintf(612,152,"--",15);

    csarrow(285,133);                      /* ptr. change */
    ipprintf(419,98,"000A");
    csarrow(193,148);
    ptprintf(419,98,"000B",14);
    Iarrow(285,148,">");

    setcolor(14);
    outtextxy(470,254,"TEST BH,BL");
    pflag0(503,132);
    pflag1(527,132);
    rprintf(517,70,"F8",13);
    }

  lchange5()
  {
    setcolor(15);
    outtextxy(470,242,"NOT CH");
    setcolor(13);
    outtextxy(470,254,"TEST BH,BL");
    rprintf(517,70,"F8",15);

    rprintf(477,152,"--",15);              /* queue */
    rprintf(503,152,"--",15);
    rprintf(530,152,"--",15);
    rprintf(558,152,"--",15);
    rprintf(585,152,"--",15);
    rprintf(612,152,"--",15);

    csarrow(285,148);                      /* ptr. change */
    ipprintf(419,98,"000C");
    csarrow(193,163);
    ptprintf(419,98,"000D",14);
    Iarrow(285,163,">");

    flag1(503,132);
    flag0(527,132);

    }





































