/* THIS FUNCTION CREATES MENU FOR MULTIPLICATION INSTRUCTIONS */

#include <stdio.h>
#include <conio.h>
#include <graphics.h>
#define ESC 0x1b

mul_menu()
{
  int c=0, x, y;

  setbkcolor(0);

  box(390,325,618,345,15);
  bkcolour1(2,391,326);

  box(0,0,635,25,15);       /* define title boundary */
  bkcolour1(4,1,1);

  box(0,25,635,330,15);       /* define explanatory section */
  bkcolour1(1,1,26);

  outtextxy(15,38,"* EXPLANATION :");

  outtextxy(140,38,"The MUL instruction is an unsigned instruction.");
  outtextxy(140,52,"It has the general form : MUL source  where `source' is a 8-");
  outtextxy(140,64,"or 16-bit general register or memory location.");
  outtextxy(140,78,"For the second operand, MUL uses the contents of AL (for");
  outtextxy(140,90,"8-bit operations) and AX (for 16-bit operactions).");
  outtextxy(140,104,"The Carry Flag(CF) and Overflow Flag(OF) tell how much of");
  outtextxy(140,116,"the product is relevant.");

  outtextxy(15,142,"* ASSUMED VALUE : AX=1234H, BX=4104H, DH=A7H.");

  outtextxy(15,168,"* EXAMPLE :-");
  outtextxy(30,188,"INSTRUCTION ; COMMENT");
  outtextxy(30,203,"MUL DH      ; AL is multiply by DH and the result is held in AX");
  outtextxy(30,218,"MUL BX      ; AX is multiply by BX and the result is held in DX(high word)");
  outtextxy(30,230,"            ; and AX(low word)");
  outtextxy(392,333,"* STRIKE ANY KEY TO BEGIN *");

  settextstyle(TRIPLEX_FONT,HORIZ_DIR,3);
  outtextxy(130,0,"MULTIPLICATION  INSTRUCTIONS");
  settextstyle(DEFAULT_FONT,HORIZ_DIR,1);

  while(c!=ESC)
  {
  c=getche();
  switch(c){
	    case ESC: clearviewport();      /* go to previous screen */
		      arith();
		      break;
	    case 'q':
	    case 'Q': closegraph();         /* quit */
		      exit(1);
	    default : clearviewport();      /* next screen */
		      mul_eg();
		      break;
	   }
    }
}

