/* the is a menu-driven program that will allows the user to create and update a linked list */
#include<stdlib.h>
#include<stdio.h>
#include<conio.h>

struct address{
char name[40];
char telnum[8];
struct address *next;
struct *prior;
}list_entry

struct address *start;
struct address *last;

void enter(), display(), search(), save(), load();

main()
{
char s[80], choice;
struct address *info;

strat = last = NULL;
for(;;){
switch(menu_select()){
case 1 : enter();
			break;
case 2 : erase();
			break;
case 3 : list();
			break;
case 4 : search();
			break;
case 5 : save();
			break;
case 6 : load();
			break;
case 7 : exit(0);
}
}
}
/*----------------------------------------*/
/* select an operation. */
menu_select()
{
char s[80];
int c;
clrscr();
printf("*********************************");
printf("\n\nthis is a menu-driven program that will allows a user to create");
printf("\nand update a record list.\n");
printf("\n\nnote : this is a case-sensitive program!\n\"");
printf("**************************************");
printf("1.enter record(s)\n");
printf("2.delete a record\n");
printf("3.list records\n");
printf("4.search for records\n");
printf("5.save records to files\n");
printf("6.load records to files\n");
printf("quit\n");
do{
printf("\nenter your choice : ");
gets(s);
c = atoi(s);
}while (c<0||c>7);
return c;
/*----------------------------------------------*/
/* enter names and telephone numbers*/
void enter()
{
struct address *info,*dls_store();
int counter;
clrscr();
printf("press <enter> when prompted for name will terminate the");
printf("\n data entering process. \n");
for(counter=1;;counter++)
{
info=(struct address *)malloc(sizeof (list_entry));
if(!info)
{
printf("\nout of memory\n");
return;
}
printf("\nnew reord %d",counter);
inputs("\nenter name : ",info->name,40);
if(!info->[0]) break;   //stop entering
inputs("Enter telephone number : ",info->telnum,7);

start=dls_store(info,start);
} /*entry loop*/

/*-----------------------------------------*/
/*This function prompts for input and accepts a string up to the length
in count. This prevents the string from overrunning its array.*/

input (prompt,s,count)
char *prompt;
char *s;
int count;

char p[255];
do
{
  printf(prompt);
  gets(p);
  if(strlen(p)>count) printf("\nToo long\n");
}while(strlen(p)>count);
strcpy(s,p);
return;

/*----------------------------------------*/

/*Create a doubly linked list in sorted order.
A pointer to the first element is returned*/
struct address *dls_store(i,top) //store in sorted order
struct address *i;               //new element
struct address *top;             //first element in list
{
 struct address *old,*p;
 if(last==NULL)                  //firat element
 {
  i->next=NULL;
  i->prior=NULL;
  last=i;
  return i;
 }
p=top;                           //start at the top of the list

old=NULL;
while(p){
  if(strcmp(p->name,i->name)<0){
	  old=p;
	  p=p->next;
	}
	else{
	    if(p->prior)[
	    p->prior->next=i;
	    i->next=p;
	    i->prior=p->prior;
	    p->prior=i;
	    return top;
	    }
	    i->next=p;           //new first element
	    i->prior=NULL;
	    p->prior=i;
	    return i;
	   }
	}
	old->next=i;             //put on end
	i->next=NULL;
	i->prior=old;
	last=i;
	return start;
       }

/*----------------------------------------------------------------------*/
//remove an element from list.
erase()
{
 struct address *info,*find();
 char s[80];
 clrscr();
 printf("<Record Delete>\n\n");
 gets(s);

 info=find(s);
 if(info){
	if(start==info){
	   start=info->next;
	   if (start) start->prior=NULL;
	   else last=NULL;
	   }
	   else{
	     info->prior->next=info->next;
	     if(info!=last)
	       info->next->prior=info->prior;
	     else
		last=info->prior;
	       }
	       free(info);        //return memory to system
	 printf("\n\nDeleting record");
	 delay(1000);
	 printf("\n\nRecord Deleted\n\a");
	 printf("\nPress Any Key To Continue.....");
	 }
      getch();
      return;
   }

/*-----------------------------------------------------------------------*/
//find the record given the name
struct address *find(name)
char *name;
{
 struct address *info;
 info=start;
 while(info)
 {
    if(!strcmp(name,info->name))return info;
    info=info->next;             //gets neat address
 }
 delay(1000);
 printf("\n\nName not found\n");
 printf("\nPress Any Key To Continue.....");
 getch();
 return NULL;                    //not found
}

/*----------------------------------------------------------------------*/
/*listing the record list on the screen */
list()
{
 register int t;
 struct address *info;
 int counter=1;
 info=start;
 clrscr();
 printf("<Records in Alphabetical order>\n");
 printf("Press <Enter> for next record.\n\n");
 while(info)
 {
  printf("\n record:%d\n",counter);
  display(info);
  info=info->next;               //next record
  counter++;
 }
 printf("\n");
 return;
}

/*----------------------------------------------------------------------*/
/*display an record*/
void display(info)
struct address *info;
{
  printf("Name:%s\n",info->name);
