/* THIS FUNCTION CREATES MENU FOR ROTATION INSTRUCTIONS */

#include <stdio.h>
#include <conio.h>
#include <graphics.h>
#define ESC 0x1b

rot_menu()
{
  int c=0, x, y;

  setbkcolor(0);

  box(390,325,618,345,15);
  bkcolour1(2,391,326);

  box(0,0,635,25,15);       /* define title boundary */
  bkcolour1(4,1,1);

  box(0,0,635,330,15);       /* define explanatory section */
  bkcolour1(1,1,26);

  outtextxy(10,38,"* EXPLANATION :");

  outtextxy(135,38,"Rotate instructions fall into two groups:");
  outtextxy(135,53,"ARITHMETIC rotates preserve the most-significant bit of the");
  outtextxy(135,65,"operand, the sign bit; they are used to operate on signed ");
  outtextxy(135,77,"numbers. The instructions used are SAL and SAR.");
  outtextxy(135,92,"LOGICAL rotates displace an operand without regard to its");
  outtextxy(135,104,"sign; they are used to operate on unsigned numbers and non-");
  outtextxy(135,116,"numbers such as masks. The instructions used are SHL and SHR.");
  outtextxy(135,131,"The rotate instructions preserve displaced bits by putting");
  outtextxy(135,143,"them back into the operand.");

  outtextxy(10,163,"* ASSUMED VALUE : AX=1231H, BL=80H, CL=02H, DX=E105H.");

  outtextxy(10,183,"* EXAMPLE :-");
  outtextxy(25,198,"INSTRUCTION ;COMMENT");
  outtextxy(25,213,"ROL AX,1    ;rotate AX 1 bit to the left and the bit displaced out of the");
  outtextxy(25,225,"            ;most significant end of AX enters the least significant end");
  outtextxy(25,240,"ROR BL,CL   ;rotate BL to right by CL times and the bit displaced out of the");
  outtextxy(25,252,"            ;least significant end of BX enters the most significant end");
  outtextxy(25,267,"RCL DX,1    ;rotate DX 1 bit to the left and the most significant end of");
  outtextxy(25,279,"            ;DX enters the least significant end through CF");
  outtextxy(25,294,"RCR DH,CL   ;rotate DH to the right by CL times and the least significant");
  outtextxy(25,306,"            ;end of DH enters the most significant end through CF");
  outtextxy(392,333,"* STRIKE ANY KEY TO BEGIN *");

  settextstyle(TRIPLEX_FONT,HORIZ_DIR,3);
  outtextxy(175,0,"ROTATE  INSTRUCTIONS");
  settextstyle(DEFAULT_FONT,HORIZ_DIR,1);

  while(c!=ESC)
  {
  c=getche();
  switch(c){
	     case ESC: clearviewport();    /* go to previous screen */
		       bit();
		       break;
	     case 'q':
	     case 'Q': closegraph();       /* quit */
		       exit(1);
	     default : clearviewport();    /* next screen */
		       rotate_eg();
		       break;
	    }
      }
}

