/* THIS FUNCTION CREATES MENU FOR SUBTRACTION INSTRUCTIONS */

#include <stdio.h>
#include <conio.h>
#include <graphics.h>
#define ESC 0x1b

sub_menu()
{
  int c=0, x, y;

  setbkcolor(0);

  box(390,325,618,345,15);
  bkcolour1(2,391,326);

  box(0,0,635,25,15);       /* define title boundary */
  bkcolour1(4,1,1);

  box(0,0,635,330,15);       /* define explanatory section */
  bkcolour1(1,1,26);

  outtextxy(15,38,"* EXPLANATION:");

  outtextxy(135,38,"The SUB and SBB instructions subtract 8- or 16-bit operands.");
  outtextxy(135,52,"The SUB instruction subtracts a source operand from a");
  outtextxy(135,64,"destination operand and returns the result in the destination.");
  outtextxy(135,78,"SBB does the same thing, except it is also subtract out the");
  outtextxy(135,90,"Carry Flag(CF).");
  outtextxy(135,104,"The DEC instruction subtracts 1 from a register or memory");
  outtextxy(135,116,"operand and it does not affect the CF.");
  outtextxy(135,130,"The NEG instruction subtracts the destination operand from");
  outtextxy(135,142,"zero, thus forming the operand's two's complement and this ");
  outtextxy(135,154,"instruction affects the flags the same as SUB. ");

  outtextxy(15,174,"* ASSUMED VALUE : AX=12E5H, BX=A733H, CX=4679H, DX=2308H.");

  outtextxy(15,194,"* EXAMPLE :-");
  outtextxy(30,209,"INSTRUCTION ; COMMENT");
  outtextxy(30,224,"SUB DX,CX   ; subtract CX from DX and places result in DX");
  outtextxy(30,239,"SUB AL,DH   ; subtract DH from AL and places result in AL");
  outtextxy(30,254,"SBB BX,AX   ; subtract AX and CF from BX and places result in BX");
  outtextxy(30,269,"SBB CH,DH");
  outtextxy(30,284,"DEC BX      ; subtract 1 from BX without affecting CF");
  outtextxy(30,299,"DEC DL");
  outtextxy(30,314,"NEG AL      ; subtract AL from 0");
  outtextxy(392,333,"* STRIKE ANY KEY TO BEGIN *");

  settextstyle(TRIPLEX_FONT,HORIZ_DIR,3);
  outtextxy(150,0,"SUBTRACTION  INSTRUCTIONS");
  settextstyle(DEFAULT_FONT,HORIZ_DIR,1);

  while(c!=ESC)
  {
  c=getche();
  switch(c){
	     case ESC : cleardevice();      /* go to the previous screen */
			arith();
			break;
	     case 'q' :
	     case 'Q' : closegraph();       /* quit */
			exit(1);
	     default : clearviewport();     /* next screen */
		       sub_eg();
		       break;
	 }
   }
}

