/* THIS FUNCTION SERVES TO DISPLAY THE EFFECTS ON THE VARIOUS */
/* SEGMENT CONTENTS AND INTERNAL REGISTERS AS THE INSTRUCTIONS */
/* IN ADDITION EXAMPLE PROGRAM ARE TRACED THROUGH */

#include <stdio.h>
#include <graphics.h>
#include <conio.h>
#include <dos.h>
#define ESC 0x1b

addition_eg()
{
  int x=470,y=206,c=0;
  Model();
  location();
  setviewport(0,0,635,349,1);
  setcolor(14);
  gprintf(&x,&y,"ADD AL,CL");
  setcolor(15);
  gprintf(&x,&y,"ADD DX,BX");
  gprintf(&x,&y,"ADD AH,05H");
  gprintf(&x,&y,"ADC BL,F7H");
  gprintf(&x,&y,"ADC CH,10H");
  gprintf(&x,&y,"INC BH");
  gprintf(&x,&y,"INC DX");

  rprintf(517,42,"1A",15);          /* registers contents */
  rprintf(517,56,"35",15);
  rprintf(517,70,"20",15);
  rprintf(517,84,"3F",15);
  rprintf(600,42,"64",15);
  rprintf(600,56,"8B",15);
  rprintf(600,70,"49",15);
  rprintf(600,84,"A7",15);

  ptprintf(419,98,"0000",14);

  rprintf(477,152,"02",14);          /* queue */
  rprintf(503,152,"C1",14);
  rprintf(530,152,"03",15);
  rprintf(558,152,"D3",15);
  rprintf(585,152,"80",15);
  rprintf(612,152,"C4",15);
				/* flags */
  outtextxy(409,132,"-");       /* OF */
  outtextxy(432,132,"-");       /* DF */
  outtextxy(456,132,"-");       /* IF */
  outtextxy(480,132,"-");       /* TF */
  outtextxy(503,132,"-");       /* SF */
  outtextxy(527,132,"-");       /* ZF */
  outtextxy(551,132,"-");       /* AF */
  outtextxy(575,132,"-");       /* PF */
  outtextxy(598,132,"-");       /* CF */

  rprintf(236,73,"02",15);        /* machine code */
  rprintf(328,73,"C1",15);
  rprintf(236,88,"03",15);
  rprintf(328,88,"D3",15);
  rprintf(236,103,"80",15);
  rprintf(328,103,"C4",15);
  rprintf(236,118,"05",15);
  rprintf(328,118,"80",15);
  rprintf(236,133,"D3",15);
  rprintf(328,133,"F7",15);
  rprintf(236,148,"80",15);
  rprintf(328,148,"D5",15);
  rprintf(236,163,"10",15);
  rprintf(328,163,"FE",15);
  rprintf(236,178,"C7",15);
  rprintf(328,178,"42",15);

  Iarrow(193,73,">");

  setviewport(0,0,639,349,1);


  apause();
  achange1();
  apause();
  achange2();
  apause();
  achange3();
  apause();
  achange4();
  apause();
  achange5();
  apause();
  achange6();
  apause();
  achange7();
  apause();
  while(c!=ESC)
  {
    c=getch();
    switch(c) {
	   case ESC : break;
	   case 'q' :
	   case 'Q' : closegraph();
		      exit(1);
           case 'r' :
	   case 'R' : cleardevice();      /* restart */
		      addition_eg();
		      break;
	   default  : sound(500);
		      delay(100);
		      nosound();
		      break;
		}
  }
  cleardevice();
  add_menu();
  }

  apause()			/* pause function */
  {
   int c=0;

   while(c!=ESC )
  {
    c=getch();
    switch(c) {
	   case ESC : break;
	   case 'q' :
	   case 'Q' : closegraph();
		      exit(1);
	   case 't' :
	   case 'T' :
		      return;
	   case 'r' :
	   case 'R' : cleardevice();
		      addition_eg();
		      break;
	   default  :
		      sound(500);
		      delay(100);
		      nosound();
		      break;
		}
  }
  cleardevice();
  add_menu();
  }



  achange1()
  {
    
    flagprin(409,132,"0",15);       /* OF */
    flagprin(432,132,"1",15);       /* DF */
    flagprin(456,132,"1",15);       /* IF */
    flagprin(480,132,"1",15);       /* TF */
    flagprin(503,132,"0",15);       /* SF */
    flagprin(527,132,"0",15);       /* ZF */
    flagprin(551,132,"0",15);       /* AF */
    flagprin(575,132,"0",15);       /* PF */
    flagprin(598,132,"0",15);
    setcolor(13);
    outtextxy(470,206,"ADD AL,CL");
    setcolor(14);
    outtextxy(470,218,"ADD DX,BX");

    rprintf(477,152,"03",14);          /* queue */
    rprintf(503,152,"D3",14);
    rprintf(530,152,"80",15);
    rprintf(558,152,"C4",15);
    rprintf(585,152,"05",15);
    rprintf(612,152,"80",15);

    csarrow(193,73);
    ipprintf(419,98,"0001");
    csarrow(285,73);
    ptprintf(419,98,"0002",14);
    Iarrow(193,88,">");

    flag1(409,132);
    flag1(503,132);
    rprintf(600,42,"AD",13);
    }

  achange2()
  {
    setcolor(15);
    outtextxy(470,206,"ADD AL,CL");
    setcolor(13);
    outtextxy(470,218,"ADD DX,BX");
    rprintf(600,42,"AD",15);

    rprintf(477,152,"80",14);
    rprintf(503,152,"C4",14);
    rprintf(530,152,"05",14);
    rprintf(558,152,"80",15);
    rprintf(585,152,"D3",15);
    rprintf(612,152,"F7",15);

    csarrow(193,88);
    ipprintf(419,98,"0003");
    csarrow(285,88);
    ptprintf(419,98,"0004",14);
    Iarrow(193,103,">");

    setcolor(14);
    outtextxy(470,230,"ADD AH,05H");
    flag0(409,132);
    flag0(503,132);
    flag1(551,132);
    rprintf(517,84,"75",13);
    rprintf(600,84,"32",13);
    }

  achange3()
  {
    setcolor(15);
    outtextxy(470,218,"ADD DX,BX");
    setcolor(13);
    outtextxy(470,230,"ADD AH,05H");
    rprintf(517,84,"75",15);
    rprintf(600,84,"32",15);

    rprintf(477,152,"80",14);
    rprintf(503,152,"D3",14);
    rprintf(530,152,"F7",14);
    rprintf(558,152,"80",15);
    rprintf(585,152,"D5",15);
    rprintf(612,152,"10",15);


    csarrow(193,103);
    ipprintf(419,98,"0005");
    csarrow(285,103);
    ipprintf(419,98,"0006");
    csarrow(193,118);
    ptprintf(419,98,"0007",14);
    Iarrow(285,118,">");

    setcolor(14);
    outtextxy(470,242,"ADC BL,F7H");

    pflag0(409,132);
    pflag0(503,132);
    flag0(551,132);
    rprintf(517,42,"1F",13);
    }

  achange4()
  {
    setcolor(15);
    outtextxy(470,230,"ADD AH,05H");
    setcolor(13);
    outtextxy(470,242,"ADC BL,F7H");
    rprintf(517,42,"1F",15);

    rprintf(477,152,"80",14);
    rprintf(503,152,"D5",14);
    rprintf(530,152,"10",14);
    rprintf(558,152,"42",15);
    rprintf(585,152,"FE",15);
    rprintf(612,152,"C7",15);

    csarrow(285,118);
    ipprintf(419,98,"0008");
    csarrow(193,133);
    ipprintf(419,98,"0009");
    csarrow(285,133);
    ptprintf(419,98,"000A",14);
    Iarrow(193,148,">");

    setcolor(14);
    outtextxy(470,254,"ADC CH,10H");
    flag1(598,132);
    flag1(575,132);
    flag1(551,132);
    flag1(503,132);
    rprintf(600,56,"82",13);
    }

  achange5()
  {
    setcolor(15);
    outtextxy(470,242,"ADC BL,F7H");
    setcolor(13);
    outtextxy(470,254,"ADC CH,10H");
    rprintf(600,56,"82",15);

    rprintf(477,152,"FE",14);
    rprintf(503,152,"C7",14);
    rprintf(530,152,"42",15);
    rprintf(558,152,"--",15);
    rprintf(585,152,"--",15);
    rprintf(612,152,"--",15);

    csarrow(193,148);
    ipprintf(419,98,"000B");
    csarrow(285,148);
    ipprintf(419,98,"000C");
    csarrow(193,163);
    ptprintf(419,98,"000D",14);
    Iarrow(285,163,">");

    setcolor(14);
    outtextxy(470,266,"INC BH");
    flag0(598,132);
    flag0(575,132);
    flag0(551,132);
    flag0(503,132);
    rprintf(517,70,"31",13);
    }

  achange6()
  {
    setcolor(15);
    outtextxy(470,254,"ADC CH,10H");
    setcolor(13);
    outtextxy(470,266,"INC BH");
    rprintf(517,70,"31",15);

    rprintf(477,152,"42",14);
    rprintf(503,152,"--",15);
    rprintf(530,152,"--",15);
    rprintf(558,152,"--",15);
    rprintf(585,152,"--",15);
    rprintf(612,152,"--",15);

    csarrow(285,163);
    ipprintf(419,98,"000E");
    csarrow(193,178);
    ptprintf(419,98,"000F",14);
    Iarrow(285,178,">");

    setcolor(14);
    outtextxy(470,278,"INC DX");
    pflag0(598,132);
    pflag0(551,132);
    pflag0(503,132);
    flag1(575,132);
    rprintf(517,56,"36",13);
    }

  achange7()
  {
    setcolor(15);
    outtextxy(470,266,"INC BH");
    setcolor(13);
    outtextxy(470,278,"INC DX");
    rprintf(517,56,"36",15);

    rprintf(477,152,"--",15);
    rprintf(503,152,"--",15);
    rprintf(530,152,"--",15);
    rprintf(558,152,"--",15);
    rprintf(585,152,"--",15);
    rprintf(612,152,"--",15);

    csarrow(285,178);
    ptprintf(419,98,"0010",14);
    Iarrow(193,193,">");

    pflag1(575,132);
    rprintf(517,84,"75",13);
    rprintf(600,84,"33",13);
    }






































