/* THIS FUNCTION CREATES MENU FOR DIVISION INSTRUCTIONS */

#include <stdio.h>
#include <conio.h>
#include <graphics.h>
#define ESC 0x1b

div_menu()
{
  int c=0, x, y;

  setbkcolor(0);

  box(390,325,618,345,15);
  bkcolour1(2,391,326);

  box(0,0,635,25,15);       /* define title boundary */
  bkcolour1(4,1,1);

  box(0,0,635,330,15);       /* define explanatory section */
  bkcolour1(1,1,26);

  outtextxy(15,38,"* EXPLANATION :");

  outtextxy(140,38,"The DIV instruction is an unsigned division.");
  outtextxy(140,52,"It has the general form : DIV source  where `source' is a 8-");
  outtextxy(140,64,"or 16-bit general register or memory location that contains");
  outtextxy(140,76,"the divisor (the value by which you want to divide).");
  outtextxy(140,90,"The dividend is a double-length operand contained in AX (for");
  outtextxy(140,102,"byte operations) or AX (for word operations).");
  outtextxy(140,116,"The DIV instruction leaves the flags undefined.");

  outtextxy(15,142,"* ASSUMED VALUE : AX=1231H, BH=41H, CH=C523H, DX=1209H.");

  outtextxy(15,168,"* EXAMPLE :-");
  outtextxy(30,188,"INSTRUCTION ; COMMENT");
  outtextxy(30,202,"DIV BH      ; AX is divided by BH and the quotient is put in AL");
  outtextxy(30,216,"            ; and the remainder is put in AH");
  outtextxy(30,228,"DIV CX      ; DX, AX is divided by CX and the quotient is put in AX");
  outtextxy(30,240,"            ; and the remainder is put in DX");
  outtextxy(392,333,"* STRIKE ANY KEY TO BEGIN *");

  settextstyle(TRIPLEX_FONT,HORIZ_DIR,3);
  outtextxy(170,0,"DIVISION  INSTRUCTIONS");
  settextstyle(DEFAULT_FONT,HORIZ_DIR,1);

  while(c!=ESC)
  {
  c=getche();
  switch(c){
	     case ESC: clearviewport();     /* go to previous screen */
		       arith();
		       break;
	     case 'q':
	     case 'Q': closegraph();        /* quit */
		       exit(1);
	     default : clearviewport();     /* next screen */
		       div_eg();
		       break;
	  }
  }
}

