/* THIS FUNCTION SERVES TO DISPLAY THE EFFECTS ON THE VARIOUS */
/* SEGMENT CONTENTS AND INTERNAL REGISTERS AS THE INSTRUCTIONS */
/* IN DIVISION EXAMPLE PROGRAM ARE TRACED THROUGH */

#include <stdio.h>
#include <graphics.h>
#include <conio.h>
#include <dos.h>
#define ESC 0x1b
void sound(unsigned frequency);
void delay(unsigned milliseconds);
void nosound(void);

div_eg()
{
  int x=470,y=206,c=0;
  Model();
  location();
  setviewport(0,0,635,349,1);
  setcolor(14);
  gprintf(&x,&y,"DIV BH");
  setcolor(15);
  gprintf(&x,&y,"DIV CX");

  rprintf(517,42,"12",15);	   /* regs. initialised */
  rprintf(517,56,"41",15);
  rprintf(517,70,"C5",15);
  rprintf(517,84,"12",15);
  rprintf(600,42,"31",15);
  rprintf(600,56,"--",15);
  rprintf(600,70,"23",15);
  rprintf(600,84,"09",15);

  ptprintf(419,98,"0000",14);

  rprintf(477,152,"F6",14);          /* queue */
  rprintf(503,152,"F7",14);
  rprintf(530,152,"F7",15);
  rprintf(558,152,"F1",15);
  rprintf(585,152,"--",15);
  rprintf(612,152,"--",15);
                                /* flags initialised */
  outtextxy(409,132,"-");       /* OF */
  outtextxy(432,132,"-");       /* DF */
  outtextxy(456,132,"-");       /* IF */
  outtextxy(480,132,"-");       /* TF */
  outtextxy(503,132,"-");       /* SF */
  outtextxy(527,132,"-");       /* ZF */
  outtextxy(551,132,"-");       /* AF */
  outtextxy(575,132,"-");       /* PF */
  outtextxy(598,132,"-");       /* CF */

  rprintf(236,73,"F6",15);        /* machine code */
  rprintf(328,73,"F7",15);
  rprintf(236,88,"F7",15);
  rprintf(328,88,"F1",15);

  Iarrow(193,73,">");

  setviewport(0,0,639,349,1);


  dpause();
  dchange1();
  dpause();
  dchange2();
  dpause();
  while(c!=ESC)
  {
    c=getch();
    switch(c) {
	   case ESC : break;
	   case 'q' :
	   case 'Q' : closegraph();
		      exit(1);
	   case 'r' :
	   case 'R' : cleardevice();
		      div_eg();
		      break;
	   default  : sound(500);
		      delay(100);
		      nosound();
		      break;
		}
  }
  cleardevice();
  div_menu();
  }


  dpause()
  {
  int c=0;

  while(c!=ESC)
  {
    c=getch();
    switch(c) {
	   case ESC : break;
	   case 'q' :
	   case 'Q' : closegraph();
		      exit(1);
	   case 'r' :
	   case 'R' : cleardevice();
		      div_eg();
		      break;
	   case 't' :
	   case 'T' : return;
	   default  : sound(500);
		      delay(100);
		      nosound();
		      break;
		}
  }

  cleardevice();
  div_menu();
  }

  dchange1()
  {

    flagprin(409,132,"0",15);       /* OF */
    flagprin(432,132,"1",15);       /* DF */
    flagprin(456,132,"1",15);       /* IF */
    flagprin(480,132,"1",15);       /* TF */
    flagprin(503,132,"0",15);       /* SF */
    flagprin(527,132,"0",15);       /* ZF */
    flagprin(551,132,"0",15);       /* AF */
    flagprin(575,132,"0",15);       /* PF */
    flagprin(598,132,"0",15);       /* CF */

    setcolor(13);
    outtextxy(470,206,"DIV BH");
    setcolor(14);
    outtextxy(470,218,"DIV CX");

    rprintf(477,152,"F7",14);          /* queue */
    rprintf(503,152,"F1",14);
    rprintf(530,152,"--",15);
    rprintf(558,152,"--",15);
    rprintf(585,152,"--",15);
    rprintf(612,152,"--",15);



    csarrow(193,73);                    /* ptr. change */
    ipprintf(419,98,"0001");
    csarrow(285,73);
    ptprintf(419,98,"0002",14);
    Iarrow(193,88,">");

    rprintf(517,42,"2A",13);
    rprintf(600,42,"47",13);
    }

  dchange2()
  {
    setcolor(15);
    outtextxy(470,206,"DIV BH");
    setcolor(13);
    outtextxy(470,218,"DIV CX");
    rprintf(517,42,"2A",15);
    rprintf(600,42,"47",15);

    rprintf(477,152,"--",15);          /* queue */
    rprintf(503,152,"--",15);
    rprintf(530,152,"--",15);
    rprintf(558,152,"--",15);
    rprintf(585,152,"--",15);
    rprintf(612,152,"--",15);

    csarrow(193,88);
    ipprintf(419,98,"0003");
    csarrow(285,88);
    ptprintf(419,98,"0004",14);
    Iarrow(193,103,">");

    rprintf(517,42,"17",13);
    rprintf(600,42,"6B",13);
    rprintf(517,84,"9F",13);
    rprintf(600,84,"A6",13);

    }



















