/* THIS FUNCTION CREATES MENU FOR SHIFT INSTRUCTIONS */

#include <stdio.h>
#include <conio.h>
#include <graphics.h>
#define ESC 0x1b

shf_menu()
{
  int c=0, x, y;

  setbkcolor(0);

  box(390,325,618,345,15);
  bkcolour1(2,391,326);

  box(0,0,635,25,15);       /* define title boundary */
  bkcolour1(4,1,1);

  box(0,0,635,330,15);       /* define explanatory section */
  bkcolour1(1,1,26);

  outtextxy(15,38,"* EXPLANATION:");

  outtextxy(135,38,"Shift instructions fall into two groups:");
  outtextxy(135,62,"ARITHMETIC shifts preserve the most-significant bit of the");
  outtextxy(135,74,"operand, the sign bit; they are used to operate on signed ");
  outtextxy(135,86,"numbers. The instructions used are SAL and SAR.");
  outtextxy(135,110,"LOGICAL shifts displace an operand without regard to its sign;");
  outtextxy(135,122,"they are used to operate on unsigned numbers and non-numbers");
  outtextxy(135,134,"such as masks. The instructions used are SHL and SHR.");

  outtextxy(15,160,"* ASSUMED VALUE : AX=091AH, CL=02H, DH=1AH.");

  outtextxy(15,186,"* EXAMPLE :-");
  outtextxy(30,206,"INSTRUCTION ; COMMENT");
  outtextxy(30,221,"SHL AX,1    ; shift 1 bit to the left and does not preserve sign bit");
  outtextxy(30,233,"            ; but places a '1' in the OF if the sign ever changes");
  outtextxy(30,248,"SAL AX,1    ; does the same thing as SHL");
  outtextxy(30,263,"SAR DH,CL   ; shift content of DH to the right by CL times");
  outtextxy(30,275,"            ; and preserve the sign of the operand");
  outtextxy(30,290,"SHR AL,CL   ; shift AL by CL times to the right");
  outtextxy(392,333,"* STRIKE ANY KEY TO BEGIN *");

  settextstyle(TRIPLEX_FONT,HORIZ_DIR,3);
  outtextxy(185,0,"SHIFT  INSTRUCTIONS");
  settextstyle(DEFAULT_FONT,HORIZ_DIR,1);

  while(c!=ESC)
  {
  c=getche();
  switch(c){
	     case ESC: clearviewport();      /* go to next screen */
		       bit();
		       break;
	     case 'q':
	     case 'Q': closegraph();         /* quit */
		       exit(1);
	     default : clearviewport();      /* next screen */
		       shift_eg();
		       break;
	    }
    }
}

