/* THIS FUNCTION SERVES TO DISPLAY THE EFFECTS ON THE VARIOUS */
/* SEGMENT CONTENTS AND INTERNAL REGISTERS AS THE INSTRUCTIONS */
/* IN SHIFT EXAMPLE PROGRAM ARE TRACED THROUGH */


#include <stdio.h>
#include <graphics.h>
#include <conio.h>
#include <dos.h>
#define ESC 0x1b

shift_eg()
{
  int x=470,y=206,c=0;
  Model();
  location();
  setviewport(0,0,635,349,1);
  setcolor(14);
  gprintf(&x,&y,"SHL AX,1");
  setcolor(15);
  gprintf(&x,&y,"SAL AX,1");
  gprintf(&x,&y,"SAR DH,CL");
  gprintf(&x,&y,"SHR AL,CL");

  rprintf(517,42,"09",15);          /* register contents */
  rprintf(517,56,"--",15);
  rprintf(517,70,"--",15);
  rprintf(517,84,"1A",15);
  rprintf(600,42,"1A",15);
  rprintf(600,56,"--",15);
  rprintf(600,70,"02",15);
  rprintf(600,84,"--",15);

  ptprintf(419,98,"0000",14);

  rprintf(477,152,"D1",14);          /* queue */
  rprintf(503,152,"E0",14);
  rprintf(530,152,"D1",15);
  rprintf(558,152,"E0",15);
  rprintf(585,152,"D2",15);
  rprintf(612,152,"FE",15);
				/* flags */
  outtextxy(409,132,"-");       /* OF */
  outtextxy(432,132,"-");       /* DF */
  outtextxy(456,132,"-");       /* IF */
  outtextxy(480,132,"-");       /* TF */
  outtextxy(503,132,"-");       /* SF */
  outtextxy(527,132,"-");       /* ZF */
  outtextxy(551,132,"-");       /* AF */
  outtextxy(575,132,"-");       /* PF */
  outtextxy(598,132,"-");       /* CF */

  rprintf(236,73,"D1",15);        /* machine code */
  rprintf(328,73,"E0",15);
  rprintf(236,88,"D1",15);
  rprintf(328,88,"E0",15);
  rprintf(236,103,"D2",15);
  rprintf(328,103,"FE",15);
  rprintf(236,118,"D2",15);
  rprintf(328,118,"E8",15);

  Iarrow(193,73,">");

  setviewport(0,0,639,349,1);


  shpause();
  shchange1();
  shpause();
  shchange2();
  shpause();
  shchange3();
  shpause();
  shchange4();
  shpause();
  while(c!=ESC)
  {
    c=getch();
    switch(c) {
           case 'q' :
	   case 'Q' : closegraph();
		      exit(1);
	   case 'r' :
	   case 'R' : cleardevice();
		      shift_eg();
		      break;
	   default  : sound(500);
		      delay(100);
		      nosound();
		      break;
		}
  }
  cleardevice();
  shf_menu();
  }


  shpause()
  {
  int c=0;

  while(c!=ESC)
  {
    c=getch();
    switch(c) {
	   case 'q' :
	   case 'Q' : closegraph();
		      exit(1);
	   case 'r' :
	   case 'R' : cleardevice();
		      shift_eg();
		      break;
	   case 't' :
	   case 'T' : return;
	   default  : break;
		}
  }

  cleardevice();
  shf_menu();
  }

  shchange1()
  {
    
    flagprin(409,132,"0",15);       /* OF */
    flagprin(432,132,"1",15);       /* DF */
    flagprin(456,132,"1",15);       /* IF */
    flagprin(480,132,"1",15);       /* TF */
    flagprin(503,132,"0",15);       /* SF */
    flagprin(527,132,"0",15);       /* ZF */
    flagprin(551,132,"0",15);       /* AF */
    flagprin(575,132,"0",15);       /* PF */
    flagprin(598,132,"0",15);       /* CF */
    setcolor(13);
    outtextxy(470,206,"SHL AX,1");
    setcolor(14);
    outtextxy(470,218,"SAL AX,1");

    rprintf(477,152,"D1",14);          /* queue */
    rprintf(503,152,"E0",14);
    rprintf(530,152,"D2",15);
    rprintf(558,152,"FE",15);
    rprintf(585,152,"D2",15);
    rprintf(612,152,"E8",15);


    csarrow(193,73);		        /* ptr. change */
    ipprintf(419,98,"0001");
    csarrow(285,73);
    ptprintf(419,98,"0002",14);
    Iarrow(193,88,">");

    flag1(551,132);
    rprintf(517,42,"12",13);
    rprintf(600,42,"34",13);
    }

  shchange2()
  {
    setcolor(15);
    outtextxy(470,206,"SHL AX,1");
    setcolor(13);
    outtextxy(470,218,"SAL AX,1");
    rprintf(517,43,"12",15);
    rprintf(600,43,"34",15);

    rprintf(477,152,"D2",14);
    rprintf(503,152,"FE",14);
    rprintf(530,152,"D2",15);
    rprintf(558,152,"E8",15);
    rprintf(585,152,"--",15);
    rprintf(612,152,"--",15);

    csarrow(193,88);
    ipprintf(419,98,"0003");
    csarrow(285,88);
    ptprintf(419,98,"0004",14);
    Iarrow(193,103,">");

    setcolor(14);
    outtextxy(470,230,"SAR DH,CL");
    flag0(551,132);
    rprintf(517,42,"24",13);
    rprintf(600,42,"68",13);
    }

  shchange3()
  {
    setcolor(15);
    outtextxy(470,218,"SAL AX,1");
    setcolor(13);
    outtextxy(470,230,"SAR DH,CL");
    rprintf(517,42,"24",15);
    rprintf(600,42,"68",15);

    rprintf(477,152,"D2",14);
    rprintf(503,152,"E8",14);
    rprintf(530,152,"--",15);
    rprintf(558,152,"--",15);
    rprintf(585,152,"--",15);
    rprintf(612,152,"--",15);

    csarrow(193,103);
    ipprintf(419,98,"0005");
    csarrow(285,103);
    ptprintf(419,98,"0006",14);
    Iarrow(193,118,">");

    setcolor(14);
    outtextxy(470,242,"SHR AL,CL");
    flag1(551,132);
    flag1(575,132);
    flag1(598,132);
    rprintf(517,84,"06",13);
    }

  shchange4()
  {
    setcolor(15);
    outtextxy(470,230,"SAR DH,CL");
    setcolor(13);
    outtextxy(470,242,"SHR AL,CL");
    rprintf(517,84,"06",15);

    rprintf(477,152,"--",15);
    rprintf(503,152,"--",15);
    rprintf(530,152,"--",15);
    rprintf(558,152,"--",15);
    rprintf(585,152,"--",15);
    rprintf(612,152,"--",15);

    csarrow(193,118);
    ipprintf(419,98,"0007");
    csarrow(285,118);
    ptprintf(419,98,"0008",14);
    Iarrow(193,133,">");

    pflag1(551,132);
    flag0(575,132);
    flag0(598,132);
    rprintf(600,42,"1A",13);
    }
































