/* THIS FUNCTION SERVES TO DISPLAY THE EFFECTS ON THE VARIOUS */
/* SEGMENT CONTENTS AND INTERNAL REGISTERS AS THE INSTRUCITONS */
/* IN SUBTRACTION EXAMPLE PROGRAM ARE TRACED THROUGH */

#include <stdio.h>
#include <graphics.h>
#include <conio.h>
#include <dos.h>
#define ESC 0x1b

sub_eg()
{
  int x=470,y=206,c=0;
  Model();
  location();
  setviewport(0,0,635,349,1);
  setcolor(14);
  gprintf(&x,&y,"SUB DX,CX");
  setcolor(15);
  gprintf(&x,&y,"SUB AL,DH");
  gprintf(&x,&y,"SBB BX,AX");
  gprintf(&x,&y,"SBB CH,DH");
  gprintf(&x,&y,"DEC BX");
  gprintf(&x,&y,"DEC DL");
  gprintf(&x,&y,"NEG AL");

  rprintf(517,42,"12",15);	    /* 	registers initialised */
  rprintf(517,56,"A7",15);
  rprintf(517,70,"46",15);
  rprintf(517,84,"23",15);
  rprintf(600,42,"E5",15);
  rprintf(600,56,"33",15);
  rprintf(600,70,"79",15);
  rprintf(600,84,"08",15);

  ptprintf(419,98,"0000",14);

  rprintf(477,152,"2B",14);          /* queue */
  rprintf(503,152,"D1",14);
  rprintf(530,152,"2A",15);
  rprintf(558,152,"C6",15);
  rprintf(585,152,"1B",15);
  rprintf(612,152,"D8",15);
                                /* flags initialised */
  outtextxy(409,132,"-");       /* OF */
  outtextxy(432,132,"-");       /* DF */
  outtextxy(456,132,"-");       /* IF */
  outtextxy(480,132,"-");       /* TF */
  outtextxy(503,132,"-");       /* SF */
  outtextxy(527,132,"-");       /* ZF */
  outtextxy(551,132,"-");       /* AF */
  outtextxy(575,132,"-");       /* PF */
  outtextxy(598,132,"-");       /* CF */

  rprintf(236,73,"2B",15);        /* machine code */
  rprintf(328,73,"D1",15);
  rprintf(236,88,"2A",15);
  rprintf(328,88,"C6",15);
  rprintf(236,103,"1B",15);
  rprintf(328,103,"D8",15);
  rprintf(236,118,"1A",15);
  rprintf(328,118,"EE",15);
  rprintf(236,133,"4B",15);
  rprintf(328,133,"FE",15);
  rprintf(236,148,"CA",15);
  rprintf(328,148,"F6",15);
  rprintf(236,163,"D8",15);

  Iarrow(193,73,">");

  setviewport(0,0,639,349,1);


  spause();
  schange1();
  spause();
  schange2();
  spause();
  schange3();
  spause();
  schange4();
  spause();
  schange5();
  spause();
  schange6();
  spause();
  schange7();
  spause();
  while(c!=ESC)
  {
    c=getch();
    switch(c) {
	   case ESC : break;
	   case 'q' :
	   case 'Q' : closegraph();
		      exit(1);
	   case 'r' :
	   case 'R' : sub_eg();
	   default  : sound(500);
		      delay(100);
		      nosound();
		      break;
		}
  }
  cleardevice();
  sub_menu();
  }

  spause()
  {
  int c=0;

  while(c!=ESC)
  {
    c=getch();
    switch(c) {
	   case ESC : break;
	   case 'q' :
	   case 'Q' : closegraph();
		      exit(1);
	   case 'r' :
	   case 'R' : sub_eg();
	   case 't' :
	   case 'T' : return;
	   default  : sound(500);
		      delay(100);
		      nosound();
		      break;
		}
  }

  cleardevice();
  sub_menu();
  }

  schange1()
  {
    
    flagprin(409,132,"0",15);       /* OF */
    flagprin(432,132,"1",15);       /* DF */
    flagprin(456,132,"1",15);       /* IF */
    flagprin(480,132,"1",15);       /* TF */
    flagprin(503,132,"0",15);       /* SF */
    flagprin(527,132,"0",15);       /* ZF */
    flagprin(551,132,"0",15);       /* AF */
    flagprin(575,132,"0",15);       /* PF */
    flagprin(598,132,"0",15);       /* CF */
    setcolor(13);
    outtextxy(470,206,"SUB DX,CX");
    setcolor(14);
    outtextxy(470,218,"SUB AL,DH");

    rprintf(477,152,"2A",14);          /* queue */
    rprintf(503,152,"C6",14);
    rprintf(530,152,"1B",15);
    rprintf(558,152,"D8",15);
    rprintf(585,152,"1A",15);
    rprintf(612,152,"EE",15);


    csarrow(193,73);                    /* ptr. change */
    ipprintf(419,98,"0001");
    csarrow(285,73);
    ptprintf(419,98,"0002",14);
    Iarrow(193,88,">");

    flag1(598,132);
    flag1(551,132);
    flag1(503,132);
    rprintf(517,84,"DC",13);
    rprintf(600,84,"8F",13);
    }

  schange2()
  {
    setcolor(15);
    outtextxy(470,206,"SUB DX,CX");
    setcolor(13);
    outtextxy(470,218,"SUB AL,DH");
    rprintf(517,84,"DC",15);
    rprintf(600,84,"8F",15);

    rprintf(477,152,"1B",14);
    rprintf(503,152,"D8",14);
    rprintf(530,152,"1A",15);
    rprintf(558,152,"EE",15);
    rprintf(585,152,"4B",15);
    rprintf(612,152,"FE",15);

    csarrow(193,88);
    ipprintf(419,98,"0003");
    csarrow(285,88);
    ptprintf(419,98,"0004",14);
    Iarrow(193,103,">");

    setcolor(14);
    outtextxy(470,230,"SBB BX,AX");
    pflag1(551,132);
    flag0(598,132);
    flag0(503,132);
    flag1(575,132);
    rprintf(600,42,"09",13);
    }

  schange3()
  {
    setcolor(15);
    outtextxy(470,218,"SUB AL,DH");
    setcolor(13);
    outtextxy(470,230,"SBB BX,AX");
    rprintf(600,42,"09",15);

    rprintf(477,152,"1A",14);
    rprintf(503,152,"EE",14);
    rprintf(530,152,"4B",15);
    rprintf(558,152,"FE",15);
    rprintf(585,152,"CA",15);
    rprintf(612,152,"F6",15);

    csarrow(193,103);
    ipprintf(419,98,"0005");
    csarrow(285,103);
    ptprintf(419,98,"0006",14);
    Iarrow(193,118,">");

    setcolor(14);
    outtextxy(470,242,"SBB CH,DH");
    pflag0(598,132);
    flag0(575,132);
    flag1(503,132);
    rprintf(517,56,"95",13);
    rprintf(600,56,"2A",13);
    }

  schange4()
  {
    setcolor(15);
    outtextxy(470,230,"SBB BX,AX");
    setcolor(13);
    outtextxy(470,242,"SBB CH,DH");
    rprintf(517,56,"95",15);
    rprintf(600,56,"2A",15);

    rprintf(477,152,"4B",14);
    rprintf(503,152,"FE",15);
    rprintf(530,152,"CA",15);
    rprintf(558,152,"F6",15);
    rprintf(585,152,"D8",15);
    rprintf(612,152,"--",15);

    csarrow(193,118);
    ipprintf(419,98,"0007");
    csarrow(285,118);
    ptprintf(419,98,"0008",14);
    Iarrow(193,133,">");

    setcolor(14);
    outtextxy(470,254,"DEC BX");
    flag1(575,132);
    flag0(503,132);
    flag1(598,132);
    rprintf(517,70,"6A",13);
    }

  schange5()
  {
    setcolor(15);
    outtextxy(470,242,"SBB CH,DH");
    setcolor(13);
    outtextxy(470,254,"DEC BX");
    rprintf(517,70,"6A",15);

    rprintf(477,152,"FE",14);
    rprintf(503,152,"CA",14);
    rprintf(530,152,"F6",15);
    rprintf(558,152,"D8",15);
    rprintf(585,152,"--",15);
    rprintf(612,152,"--",15);

    csarrow(193,133);
    ptprintf(419,98,"0009",14);
    Iarrow(285,133,">");

    setcolor(14);
    outtextxy(470,266,"DEC DL");
    pflag1(598,132);
    flag0(575,132);
    flag0(551,132);
    flag1(503,132);
    rprintf(517,56,"95",13);
    rprintf(600,56,"29",13);
    }

  schange6()
  {
    setcolor(15);
    outtextxy(470,254,"DEC BX");
    setcolor(13);
    outtextxy(470,266,"DEC DL");
    rprintf(517,56,"95",15);
    rprintf(600,56,"29",15);

    rprintf(477,152,"F6",14);
    rprintf(503,152,"D8",14);
    rprintf(530,152,"--",15);
    rprintf(558,152,"--",15);
    rprintf(585,152,"--",15);
    rprintf(612,152,"--",15);

    csarrow(285,133);
    ipprintf(419,98,"000A");
    csarrow(193,148);
    ptprintf(419,98,"000B",14);
    Iarrow(285,148,">");

    setcolor(14);
    outtextxy(470,278,"NEG AL");
    pflag0(551,132);
    pflag1(503,132);
    flag1(575,132);
    rprintf(600,84,"8E",13);
    }

  schange7()
  {
    setcolor(15);
    outtextxy(470,266,"DEC DL");
    setcolor(13);
    outtextxy(470,278,"NEG AL");
    rprintf(600,84,"8E",15);

    rprintf(477,152,"--",15);
    rprintf(503,152,"--",15);
    rprintf(530,152,"--",15);
    rprintf(558,152,"--",15);
    rprintf(585,152,"--",15);
    rprintf(612,152,"--",15);

    csarrow(285,148);
    ipprintf(419,98,"000C");
    csarrow(193,163);
    ptprintf(419,98,"000D",14);
    Iarrow(285,163,">");

    setcolor(14);
    flag0(575,132);
    flag1(551,132);
    rprintf(600,42,"F7",13);
    }






































